'~~[author]~~
'Daniel Schober
'~~[/author]~~
'
'~~[emailAddress]~~
'script (at) ftpnet (dot)de
'~~[/emailAddress]~~
'
'~~[scriptType]~~
'vbscript
'~~[/scriptType]~~

'~~[subType]~~
'SystemAdministration
'~~[/subType]~~

'~~[keywords]~~
'windows, microsoft, active directory, attribute, schema, logon script, dfs
'~~[/keywords]~~
'
' Das Script verbindet das persnliche Laufwerk eines Benutzers auf einem bestimmten Laufwerksbuchstaben. Wenn noch kein
' persnlicher Ordner existiert, dann wird einer angelegt. Dabei wird jeden Monat ein anderer Server zur Neuanlage benutzt.
' Zudem findet eine Plausibelittsprfung des Attributes statt.
'
'*******************************************************************************
Option Explicit

Dim objRootDSE, objDNSDomain, objFso, objShell, objDrives, objLog
Dim objUser, objUserID, objSysInfo, objNetwork, objUsername, objHomeDir
Dim DriveLetter, HomeDirPath, FoldernameUcase, TimeStart, ScriptDuration
Dim CountHomeStores, UserHomeID, i, Logfile, WshSysEnv, WshShell
Dim MappedDrivePathRename, MappedDrivePathName, Regvalue, errString

' Starte den Timer

TimeStart = Timer

' Verbindung mit dem Active Directory

Set objRootDSE = GetObject("LDAP://RootDSE")
objDNSDomain = objRootDSE.Get("DefaultNamingContext")

'*******************************************************************************
' Trage Accountinformationen zusammen

Set objNetwork = CreateObject("WScript.Network")
Set objSysInfo = CreateObject("ADSystemInfo")
Set objUser = GetObject("LDAP://" & objSysInfo.UserName)
objUsername = objUser.sAMAccountName
objHomeDir = objUser.homeDirectory

Set objShell = CreateObject("Shell.Application")
Set objFso = CreateObject("Scripting.FileSystemObject")
Set WshShell = WScript.CreateObject("WScript.Shell")
Set WshSysEnv = WshShell.Environment("PROCESS")

'*******************************************************************************
' Das ist der Bereich, der auf die jeweilige Umgebung angepasst werden muss
' 
' Welcher Laufwerksbuchstabe soll fr das Benutzerverzeichnis gesetzt werden?

DriveLetter = "U:"

' Wie lautet der Pfad zum DFS? (ohne "\" am Ende!)
' Bsp: \\dfs-path\folder
' Bsp: \\mydomain.local\Global\User

HomeDirPath = "\\liesst.mit\Users"

' Wie viele verschiedene Benutzerordnerablagepunkte soll es geben?
' Diese Zahl muss der Anzahl der erstellten DFS Links entsprechen
' Zahl zwischen 1 - 12

CountHomeStores = 4

' Soll der persnliche Ordnername eines neuen Benutzers gro geschrieben werden (bei Neuanlage)?
' Hintergrund: Der Samaccountname knnte teils gro teils klein geschrieben werden. Hiermit knnen die Ordnernamen angepasst werden.
' Kosmetischer Faktor - fr die Funktion des Scripts unwichtig
' Entweder True oder False (False schaltet die Funktion ab)

FoldernameUcase = "True"

' Soll der Netzwerkpfad des gemappten Benutzerlaufwerks umbenannt werden, damit der kryptische Name versteckt wird?
' Kosmetischer Faktor - fr die Funktion des Scripts unwichtig
' Entweder True oder False (False schaltet die Funktion ab)

MappedDrivePathRename = "True"
MappedDrivePathName = "Persnlicher Ordner"

' Wohin soll das Logfile lokal geschrieben werden?
' Das Logfile wird jedesmal berschrieben

Logfile = WshSysEnv("TEMP") & "\" & "logon-results.txt"

' End of customization.
'*******************************************************************************
'*******************************************************************************
Set objLog = objFso.CreateTextFile(Logfile, True)
objLog.WriteLine "------------------------------------------------------------------"
objLog.WriteLine "Start des Scripts: " & (cstr(Now))
objLog.WriteLine "Benutzerobjekt = " & objSysInfo.UserName
objLog.WriteLine "SamAccountName = " & objUser.sAMAccountName
objLog.WriteLine "Konfigurierter Laufwerksbuchstabe = " & DriveLetter
objLog.WriteLine "Konfigurierter DFS Pfad = " & HomeDirPath
objLog.WriteLine "Anzahl konfigurierter Benutzerordnerablagepunkte ist " & CountHomeStores & ". Daraus ergeben sich folgende DFS-Links:"
For i = 1 To CountHomeStores
	objLog.WriteLine HomeDirPath & "\" & i
Next
'*******************************************************************************
' Lese das Attribute aus dem Active Directory
' Ich habe mich fr den Wert Pager entschieden, da dieser heute kaum noch genutzt wird
' wird ein alternatives Attribute genutzt, dann im Script "pager" durch das neue Attribut ersetzen
' Achtung bei Custom Attributen! Rechte setzen, damit der Benutzer diesen Wert ndern darf!

UserHomeID = objUser.pager
objLog.WriteLine "Ausgelesender Wert fr Attribut pager = " & UserHomeID

'*******************************************************************************
' Prfe ob das Attribute leer ist
' Wenn ja, dann hole den aktuellen Monat als Zahl
' Ist die Zahl grer als die Anzahl der Benutzerordnerablagepunkte, dann wird die Zahl um den 
' Wert der Benutzerordnerablagepunkte subtrahiert, bis die Zahl kleiner oder gleich ist
' Zudem wird der neue Wert dann ins AD geschrieben
' Das wird gemacht damit neue Benutzer jeden Monat auf einen anderen Server verteilt werden

If (IsEmpty(UserHomeID)) Then
 		UserHomeID = Month(Now)
		objLog.WriteLine "Das Attribut pager fr den User " & objUsername & " war im Active Directory nicht gepflegt."
		objLog.WriteLine "Die Nummer des aktuellen Monats = " & Month(Now) & "."
 			Do While UserHomeID+0 > CountHomeStores+0
				objLog.WriteLine "Der Wert " & UserHomeID & " ist zu gro und wird subtrahiert mit " & CountHomeStores
 				UserHomeID = UserHomeID - CountHomeStores
 			Loop
' Schreibe den neuen Wert in das Attribute des Users

objUser.Put "pager", UserHomeID
objUser.SetInfo
objLog.WriteLine "Schreibe den neuen Wert " & UserHomeID & " fr das Attribute pager ins AD."
End If

'*******************************************************************************
' Prfe ob der Wert im Active Directory valide ist

If UserHomeID+0 > CountHomeStores+0 Then
		MsgBox "Bitte informieren Sie Ihren Administrator. Der Wert fr pager des Benutzers " & objUsername & " ist " & UserHomeID & ". Die konfigurierte Anzahl der Benutzerordnerablagepunkte ist " &  CountHomeStores & ".",VBOKOnly,"Benutzerlaufwerk " & DriveLetter & " konnte nicht verbunden werden!"
' 		MsgBox "Please contact your admin. The value for pager is " & UserHomeID & " for user " & objUsername & " & ". Configured distributed home shares is " &  CountHomeStores & ".",VBOKOnly,"Drive " & DriveLetter & " couldn`t be mapped!"
ElseIf UserHomeID < 1 Then
		MsgBox "Bitte informieren Sie Ihren Administrator. Der Wert fr pager des Benutzers " & objUsername & " ist " & UserHomeID & ". Dieser Wert muss grer 0 sein, jedoch maximal " &  CountHomeStores & ".",VBOKOnly,"Benutzerlaufwerk " & DriveLetter & ": konnte nicht verbunden werden!"
' 		MsgBox "Please contact your admin. The value for pager is " & UserHomeID & " for user " & objUsername & ". The value must be at least 1, but not greater than " &  CountHomeStores & ".",VBOKOnly,"Drive " & DriveLetter & " couldn`t be mapped!"
End If

'*******************************************************************************
' Schreibe den Benutzernamen mit Grobuchstaben, wenn gewnscht.

If FoldernameUcase = "True" Then
		objUsername = ucase(objUsername)
		objLog.WriteLine "Ordnernamen umgewandelt in Grossbuchstaben -> " & objUsername
End If

'*******************************************************************************
' Prfe ob der persnliche Ordner vorhanden ist und erstelle ihn neu wenn ntig.
 
objLog.WriteLine "Prfe ob der Pfad existiert: " & HomeDirPath & "\" & UserHomeID & "\" & objUsername
If objFso.Folderexists(HomeDirPath & "\" & UserHomeID & "\" & objUsername) = false then
   		objFso.CreateFolder(HomeDirPath & "\" & UserHomeID & "\" & objUsername)
		objLog.WriteLine "Ordner existiert nicht. Erstelle den Ordner " & HomeDirPath & "\" & UserHomeID & "\" & objUsername
		Else objLog.WriteLine "Pfad existiert. Ordner muss nicht erstellt werden."
End if

'*******************************************************************************
' Trenne das Benutzerlaufwerk (wenn verbunden) und verbinde es neu.

If(objFso.DriveExists(DriveLetter)) Then
		objNetwork.RemoveNetworkDrive DriveLetter, True, True
		objLog.WriteLine "Laufwerk " & DriveLetter & " war bereits verbunden und wurde getrennt."
End If	

wscript.sleep 100
objLog.WriteLine "Versuche Laufwerk " & DriveLetter & " mit " & HomeDirPath & "\" & UserHomeID & "\" & objUsername & " zu verbinden."
On Error resume Next
objNetwork.MapNetworkDrive DriveLetter, HomeDirPath & "\" & UserHomeID & "\" & objUsername
If Err <> 0 then
	Select case Err.Number
		case -2147024891
		objLog.WriteLine err.Number & " Hat der Benutzer " & objUsername & " wirklich volle Rechte auf den Ordner " & HomeDirPath & "\" & UserHomeID & "\" & objUsername & " ?"
		case else
		objLog.WriteLine "Fehler " & err.Number & " --> " & Err.Description
	End Select	
End If
'*******************************************************************************
' Benenne den Netzwerkpfad des gemappten Benutzerlaufwerks um, wenn gewnscht.

If MappedDrivePathRename = "True" Then
		objShell.NameSpace(DriveLetter).Self.Name = MappedDrivePathName
		Else
		objShell.NameSpace(DriveLetter).Self.Name = HomeDirPath & "\" & UserHomeID
End If

objLog.WriteLine "Folgende Netzlaufwerke sind an diesem Client verbunden:"
Set objDrives = objNetwork.EnumNetworkDrives
For i = 0 to objDrives.Count-1 Step 2
		objLog.WriteLine objDrives.Item(i) & vbTab & objDrives.Item (i + 1)
Next

'*******************************************************************************
' Fange Standardfehler ab: Basisordner hat einen Wert im AD 

If Not (IsEmpty(objHomeDir)) Then
		objLog.WriteLine "--- Achtung! ---"
		objLog.WriteLine "Wenn das Laufwerk nicht mehr verbunden ist liegt das ggf. daran, das bei diesem Benutzer im AD"
		objLog.WriteLine "auf der Karteikarte Profil der Punkt Basisordner verbunden wird mit " & objHomeDir
End If

'*******************************************************************************
' Fange Standardfehler ab (Netzlaufwerk ist verschwunden, wenn UAC aktiviert ist)
' https://technet.microsoft.com/de-de/library/ee844140%28v=ws.10%29.aspx

objLog.WriteLine ""
If RegExists("HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System\EnableLinkedConnections") Then
				Regvalue = WshShell.RegRead("HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System\EnableLinkedConnections")
		If Regvalue = 1 Then
				objLog.WriteLine "Key HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System\EnableLinkedConnections vorhanden."
		Else
				objLog.WriteLine "Key EnableLinkedConnections vorhanden - Wert ist aber nicht = 1 !"
				objLog.WriteLine "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System\"
				objLog.WriteLine "RegDWORD EnableLinkedConnections=1"
				objLog.WriteLine "siehe https://technet.microsoft.com/de-de/library/ee844140%28v=ws.10%29.aspx"
		End If
Else
     objLog.WriteLine "Key HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System\EnableLinkedConnections nicht vorhanden!"
	 objLog.WriteLine "Wenn das Laufwerk " & DriveLetter & " nicht mehr verfgbar ist und UAC aktiviert ist bitte folgenden Regkey setzen und"
	 objLog.WriteLine "Computer neu starten: HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System\"
	 objLog.WriteLine "RegDWORD EnableLinkedConnections=1"
	 objLog.WriteLine "siehe https://technet.microsoft.com/de-de/library/ee844140%28v=ws.10%29.aspx"
End If
objLog.WriteLine ""

Function RegExists(regPath)

    On Error Resume Next                     
    RegExists = False                        
    If (Right(regPath, 1) <> "\") Then       
        Regvalue = WshShell.RegRead(regPath)         
        If (Err.Number=0) Then RegExists = True
    Else                                     
        Regvalue = WshShell.RegRead("HKLM\Nothing\")   
        errString = Replace(Err.Description, """HKLM\Nothing\"".", "" )
        Regvalue = WshShell.RegRead(regPath)         
        If (Err.Number=0) Then               
            RegExists = True
        Else                                
            If Replace(Err.Description, """" & regPath & """.", "" ) <> errString Then
               RegExists = True
            End If
        End If
    End If

    Set WshShell = Nothing                        
    On Error Goto 0
End Function 

'*******************************************************************************
' Berechne die Dauer, die das Script gebraucht hat

ScriptDuration = Int((Timer - TimeStart) * 1000)
objLog.WriteLine "Ende des Scripts. Die Scriptverarbeitung hat " & ScriptDuration & " Millisekunden gedauert."
objLog.WriteLine "------------------------------------------------------------------"

'*******************************************************************************
' Schliesse das Log und beende das Script.

objLog.Close
set objNetwork=nothing
WScript.Quit 